#pragma once

#include <cstdint>


// Uncomment for Version 2.0 where load cell is connected differently
//#define _HW_V_20
#define NEW_HEAVY_LOAD_CELL

// ------------------------------------------ WiFi ---------------------------------------------------------------------------------

const char *CONFIG_WIFI_SSID = "WLAN";
//const char *CONFIG_WIFI_SSID = "RepeaterWZ";
const char *CONFIG_WIFI_PASSWORD = "Bau3rWLAN";
const char *CONFIG_HOSTNAME = "smartswim";


// ------------------------------------- Hardware & Measurement Settings ------------------------------------------------------------


const uint8_t CONFIG_MEASUREMENT_AVG_COUNT = 1;     // number of measurements in normal phase
const uint8_t CONFIG_TARE_AVG_COUNT = 20;           // number of measurements in tare-phase (to find 0 )
const int CONFIG_MEASURE_DELAY = 100;               // interval in ms between measurements
const uint32_t CONFIG_SESSION_MAX_LENGTH_HOURS = 3; // maximum length of one session
const char *CONFIG_DATA_PATH = "/dat";              // folder in SPIFFS file system to store measurement data
using MeasurementT = uint16_t;                      // data type for one measurement
#ifdef NEW_HEAVY_LOAD_CELL
const int CONFIG_VALUE_DIVIDER = 8;                 // uint32 measurements are divided by this factor, before stored in uint16_t
#else
const int CONFIG_VALUE_DIVIDER = 128;               // uint32 measurements are divided by this factor, before stored in uint16_t
#endif


// ------------------------------------- Derived Settings -----------------------------------------------------------------------------

const uint32_t CONFIG_SESSION_MAX_SIZE = CONFIG_SESSION_MAX_LENGTH_HOURS * 3600 * (1000 / CONFIG_MEASURE_DELAY) * sizeof(uint16_t);
static_assert(CONFIG_SESSION_MAX_SIZE < 1024 * 1024, "Measurement data takes more than 1MiB space");

// HX711 load cell
#ifdef _HW_V_20
const int CONFIG_SCALE_DOUT_PIN = 23;
const int CONFIG_SCALE_SCK_PIN = 22;
#else
const int CONFIG_SCALE_DOUT_PIN = 22;
const int CONFIG_SCALE_SCK_PIN = 23;
#endif